package com.medcosm.pictureframe;

import javax.swing.UIManager;
import java.awt.*;

import java.util.Properties;


/**
 * A minimal program to load pictures to a full screen or bordered frame randomly
 * from a specified directory and with a specified time delay between loads.
 *
 * Kill the program by killing the frame (if running in bordered mode) or
 * pressing "esc" when the pictureframe has the keyboard focus.
 *
 * Visit medcosm.com for other marginally useful stuff.
 *
 * <p>Title: MedCosm Picture Frame</p>
 * <p>Description:Short  Minimal Electronic Picture Frame Software</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: MedCosm</p>
 * @author Alan Stein
 * @version 1.0
 */

public class Application
{
  boolean packFrame = false;
  static MainGUIFrame mgf;

  public static final String versionStr="1.3";

  //Construct the application
  public Application()
  {
    mgf = new MainGUIFrame();

    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame)
    {
      mgf.pack(); //packs frame around contents
    }
    else
    {
      mgf.validate();   //expands frame and contents to fill specified size
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = mgf.getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    mgf.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    mgf.setVisible(true);
  }


  //Main method
  public static void main(String[] args)
  {
    Properties p = new Properties(System.getProperties());

    String delay=p.getProperty("delay");
    String dir=p.getProperty("dir");
    String border=p.getProperty("border");

    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    new Application();

    if (delay==null || dir==null)
    {
    }
    else
    {
      mgf.setVisible(false);
      mgf.setParameters(Integer.parseInt(delay), dir, border!="", MainGUIFrame.PLAYMODE_RANDOM);
      mgf.startSlideShow();
    }

  }

}