package com.medcosm.pictureframe;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: MedCosm Picture Frame</p>
 * <p>Description:Short  Minimal Electronic Picture Frame Software</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: MedCosm</p>
 * @author Alan Stein
 * @version 1.1
 */

public class FrameJPGquality extends JFrame
{
  JSlider jSlider1 = new JSlider();
  JLabel jLabelVal = new JLabel();
  JPanel jPanel1 = new JPanel();
  JRadioButton jRadioButtonSzOrig = new JRadioButton();
  JRadioButton jRadioButtonSz640 = new JRadioButton();
  ButtonGroup buttonGroupSize = new ButtonGroup();
  JRadioButton jRadioButtonSz800 = new JRadioButton();
  JRadioButton jRadioButtonSz1024 = new JRadioButton();
  JRadioButton jRadioButtonSz1280 = new JRadioButton();
  JPanel jPanel2 = new JPanel();
  JTextField jTextFieldOutputDir = new JTextField();
  JButton jButtonChooseDir = new JButton();
  JLabel jLabel1 = new JLabel();

  static JFileChooser jfcDst=new JFileChooser(".");

  public final static int SIZE_ORIG=0;
  public final static int SIZE_640=1;
  public final static int SIZE_800=2;
  public final static int SIZE_1024=3;
  public final static int SIZE_1280=4;

  public FrameJPGquality()
  {
    try
    {
      jbInit();
      updateLabel();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception
  {
    this.setTitle("Output Parameters");
    jSlider1.setMajorTickSpacing(20);
    jSlider1.setMinimum(0);
    jSlider1.setMinorTickSpacing(5);
    jSlider1.setPaintLabels(true);
    jSlider1.setPaintTicks(true);
    jSlider1.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mousePressed(MouseEvent e)
      {
        jSlider1_mousePressed(e);
      }
      public void mouseReleased(MouseEvent e)
      {
        jSlider1_mouseReleased(e);
      }
    });
    jLabelVal.setForeground(Color.black);
    jLabelVal.setMaximumSize(new Dimension(20, 40));
    jLabelVal.setMinimumSize(new Dimension(40, 40));
    jLabelVal.setPreferredSize(new Dimension(40, 40));
    jLabelVal.setHorizontalAlignment(SwingConstants.CENTER);
    jLabelVal.setText("XXXX");
    jRadioButtonSzOrig.setSelected(true);
    jRadioButtonSzOrig.setText("Orig Size");
    jRadioButtonSz640.setText("640x480");
    jRadioButtonSz800.setText("800x600");
    jRadioButtonSz1024.setText("1024x768");
    jRadioButtonSz1280.setText("1280x1024");
    jTextFieldOutputDir.setPreferredSize(new Dimension(270, 21));
    jTextFieldOutputDir.setText("");
    jButtonChooseDir.setActionCommand("jButtonFileChoose");
    jButtonChooseDir.setText("...");
    jButtonChooseDir.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButtonChooseDir_actionPerformed(e);
      }
    });
    jLabel1.setText("Output Dir");
    this.getContentPane().add(jSlider1, BorderLayout.CENTER);
    this.getContentPane().add(jLabelVal,  BorderLayout.EAST);
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jRadioButtonSzOrig, null);
    jPanel1.add(jRadioButtonSz640, null);
    jPanel1.add(jRadioButtonSz800, null);
    jPanel1.add(jRadioButtonSz1024, null);
    jPanel1.add(jRadioButtonSz1280, null);
    this.getContentPane().add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jTextFieldOutputDir, null);
    jPanel2.add(jButtonChooseDir, null);
    buttonGroupSize.add(jRadioButtonSzOrig);
    buttonGroupSize.add(jRadioButtonSz640);
    buttonGroupSize.add(jRadioButtonSz1280);
    buttonGroupSize.add(jRadioButtonSz1024);
    buttonGroupSize.add(jRadioButtonSz800);
  }

  void jSlider1_mousePressed(MouseEvent e)
  {
    updateLabel();
  }

  void jSlider1_mouseReleased(MouseEvent e)
  {
    updateLabel();
  }

  void updateLabel()
  {
    jLabelVal.setText(""+jSlider1.getValue());
  }

  public void setOutputDir(String dir)
  {
    jTextFieldOutputDir.setText(dir);
  }


  public String getOutputDir()
  {
    return jTextFieldOutputDir.getText();
  }

  /**
   * get JPG quality (0-100)
   * @return JPG quality from jSlider setting
   */
  public int getJPGquality()
  {
    return(jSlider1.getValue());
  }

  public int getJPGSize()
  {
    int retVal=0;

    if(jRadioButtonSz640.isSelected())
      retVal=SIZE_640;
    else
    if(jRadioButtonSz800.isSelected())
      retVal=SIZE_800;
    else
    if(jRadioButtonSz1024.isSelected())
      retVal=SIZE_1024;
    else
    if(jRadioButtonSz1280.isSelected())
      retVal=SIZE_1280;
    else
      retVal=SIZE_ORIG;

    return retVal;
  }

  void jButtonChooseDir_actionPerformed(ActionEvent e)
  {
    jfcDst.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    jfcDst.setCurrentDirectory(new java.io.File(jTextFieldOutputDir.getText()));  //start chooser with current filedir

    int returnVal = jfcDst.showOpenDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      jTextFieldOutputDir.setText(jfcDst.getSelectedFile().toString());
    }

  }


}