package com.medcosm.pictureframe;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

import java.io.*;


import com.medcosm.pictureframe.*;
/**
 * <p>Title: MedCosm Picture Frame</p>
 * <p>Description:Short  Minimal Electronic Picture Frame Software</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: MedCosm</p>
 * @author Alan Stein
 * @version 1.0
 */

public class MainGUIFrame extends JFrame implements Runnable
{
  public static final int PLAYMODE_RANDOM=0;
  public static final int PLAYMODE_SEQUENTIAL=1;
  public static final int PLAYMODE_SAVE_PICTURES=2;

  int playMode=PLAYMODE_RANDOM;

  boolean modeCLI=false;

  Thread thread=null;
  int currentPicIdx=0;

  FrameJPGquality jFrameJPGquality=new FrameJPGquality();

  PictureFrame pictureframe=null;

  JFileChooser jfcSrc=null;
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JSlider jSliderInterval = new JSlider();
  JTextField jTextFieldInterval = new JTextField();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  JPanel jPanel4 = new JPanel();
  JRadioButton jRadioButtonSequential = new JRadioButton();
  JPanel jPanel3 = new JPanel();
  JLabel jLabel2 = new JLabel();
  JTextField jTextFieldFilePath = new JTextField();
  JButton jButtonFPbrowse = new JButton();
  ButtonGroup buttonGroupImgPlayMode = new ButtonGroup();
  JButton JButtonPlay = new JButton();
  JPanel jPanel5 = new JPanel();
  JRadioButton jRadioButtonRandom = new JRadioButton();
  JPanel jPanel6 = new JPanel();
  JRadioButton jRadioButtonFullScreen = new JRadioButton();
  JRadioButton jRadioButtonWindow = new JRadioButton();
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItemExit = new JMenuItem();
  JMenu jMenu2 = new JMenu();
  JMenuItem jMenuItemAbout = new JMenuItem();
  ButtonGroup buttonGroupScreenMode = new ButtonGroup();
  JCheckBox jCheckBoxDate = new JCheckBox();
  JPanel jPanel7 = new JPanel();
  JPanel jPanel8 = new JPanel();
  JPanel jPanelAspect = new JPanel();
  ButtonGroup buttonGroupAspectMode = new ButtonGroup();
  JRadioButton jRadioButtonPreserveAspect = new JRadioButton();
  JRadioButton jRadioButtonDistort = new JRadioButton();
  JMenu jMenu3 = new JMenu();
  JMenuItem jMenuItemOutputImages = new JMenuItem();
  JRadioButtonMenuItem jRadioButtonMenuItemCPUfast = new JRadioButtonMenuItem();
  JRadioButtonMenuItem jRadioButtonMenuItemCPUslow = new JRadioButtonMenuItem();
  ButtonGroup buttonGroupCPUspeed = new ButtonGroup();
  JMenuItem jMenuItemSetOutputParam = new JMenuItem();

  public MainGUIFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    this.setSize(new Dimension(400, 300));
    this.setTitle("MedCosm Picture Frame");

    jLabel1.setText("Interval");
    jSliderInterval.setMajorTickSpacing(10);
    jSliderInterval.setPaintTicks(true);
    jSliderInterval.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseReleased(MouseEvent e)
      {
        jSliderInterval_mouseReleased(e);
      }
    });
    jTextFieldInterval.setOpaque(true);
    jTextFieldInterval.setPreferredSize(new Dimension(57, 21));
    jTextFieldInterval.setText("30");
    jSliderInterval.setValue(Integer.parseInt(jTextFieldInterval.getText()));
    jPanel1.setLayout(verticalFlowLayout1);
    jRadioButtonSequential.setText("Sequential");
    jLabel2.setText("Directory");
    jTextFieldFilePath.setPreferredSize(new Dimension(180, 21));
    jTextFieldFilePath.setText("");
    jButtonFPbrowse.setActionCommand("jButtonFPbrowse");
    jButtonFPbrowse.setText("...");
    jButtonFPbrowse.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButtonFPbrowse_actionPerformed(e);
      }
    });
    JButtonPlay.setText("Start Slide Show");
    JButtonPlay.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        JButtonPlay_actionPerformed(e);
      }
    });
    jRadioButtonRandom.setSelected(true);
    jRadioButtonRandom.setText("Random");
    jPanel5.setBorder(BorderFactory.createRaisedBevelBorder());
    jRadioButtonFullScreen.setSelected(true);
    jRadioButtonFullScreen.setText("Full Screen");
    jRadioButtonFullScreen.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jRadioButtonFullScreen_actionPerformed(e);
      }
    });
    jRadioButtonWindow.setText("Window");
    jRadioButtonWindow.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jRadioButtonWindow_actionPerformed(e);
      }
    });
    jPanel6.setBorder(BorderFactory.createRaisedBevelBorder());
    jMenu1.setText("File");
    jMenuItemExit.setText("Exit");
    jMenuItemExit.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItemExit_actionPerformed(e);
      }
    });
    jMenu2.setText("Help");
    jMenuItemAbout.setText("About...");
    jMenuItemAbout.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItemAbout_actionPerformed(e);
      }
    });
    jCheckBoxDate.setText("Show Date");
    jPanel7.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel4.setBorder(BorderFactory.createEtchedBorder());
    jPanel8.setBorder(BorderFactory.createRaisedBevelBorder());
    jRadioButtonPreserveAspect.setText("Windowed");
    jRadioButtonDistort.setSelected(true);
    jRadioButtonDistort.setText("Fullscreen");
    jPanelAspect.setBorder(BorderFactory.createRaisedBevelBorder());
    jMenu3.setText("Misc");
    jMenuItemOutputImages.setText("Output New Images");
    jMenuItemOutputImages.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItemOutputImages_actionPerformed(e);
      }
    });
    jRadioButtonMenuItemCPUfast.setText("Fast Machine");
    jRadioButtonMenuItemCPUslow.setSelected(true);
    jRadioButtonMenuItemCPUslow.setText("Slow Machine");
    jMenuItemSetOutputParam.setText("Set Output Parameters");
    jMenuItemSetOutputParam.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItemSetOutputParam_actionPerformed(e);
      }
    });
    buttonGroupCPUspeed.add(jRadioButtonMenuItemCPUfast);
    buttonGroupCPUspeed.add(jRadioButtonMenuItemCPUslow);
    jPanelAspect.add(jRadioButtonPreserveAspect, null);
    jPanelAspect.add(jRadioButtonDistort, null);
    jPanel4.add(jPanel5, null);
    jPanel5.add(jRadioButtonRandom, null);
    jPanel5.add(jRadioButtonSequential, null);
    jPanel1.add(jPanel3, null);
    jPanel3.add(jLabel2, null);
    jPanel3.add(jTextFieldFilePath, null);
    jPanel1.add(jPanel4, null);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel2, null);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jSliderInterval, null);
    jPanel2.add(jTextFieldInterval, null);
    jPanel3.add(jButtonFPbrowse, null);
    buttonGroupImgPlayMode.add(jRadioButtonSequential);
    this.getContentPane().add(JButtonPlay,  BorderLayout.SOUTH);
    jPanel4.add(jPanel6, null);
    jPanel6.add(jRadioButtonFullScreen, null);
    jPanel6.add(jRadioButtonWindow, null);
    jPanel1.add(jPanel7, null);
    jPanel7.add(jPanel8, null);
    jPanel8.add(jCheckBoxDate, null);
    jPanel7.add(jPanelAspect, null);
    jMenuBar1.add(jMenu1);
    jMenuBar1.add(jMenu3);
    jMenuBar1.add(jMenu2);
    jMenu1.add(jMenuItemExit);
    jMenu2.add(jMenuItemAbout);
    buttonGroupImgPlayMode.add(jRadioButtonRandom);
    buttonGroupScreenMode.add(jRadioButtonFullScreen);
    buttonGroupScreenMode.add(jRadioButtonWindow);
    this.setJMenuBar(jMenuBar1);
    buttonGroupAspectMode.add(jRadioButtonDistort);
    buttonGroupAspectMode.add(jRadioButtonPreserveAspect);
    jMenu3.add(jMenuItemSetOutputParam);
    jMenu3.add(jMenuItemOutputImages);
    jMenu3.addSeparator();
    jMenu3.add(jRadioButtonMenuItemCPUfast);
    jMenu3.add(jRadioButtonMenuItemCPUslow);
  }

  void jMenuItemExit_actionPerformed(ActionEvent e)
  {
    System.exit(0);
  }

  void jMenuItemAbout_actionPerformed(ActionEvent e)
  {
      JOptionPane.showMessageDialog(this, "MedCosm Picture Frame\n\n"+
          "This program shows a continuous random or sequential slideshow\n"+
          "onscreen.  It also can be used to write images with a superimposed\n"+
          "date, images with reduced (compressed) image quality, and \n"+
          "images with reduced resolution.\n\n"+
          "Execution occurs from the command line, for example:\n"+
          "java -Ddir=/pics -Ddelay=30 [-Dborder=true] -jar pictureframe.jar\n"+
          "or it may be run as a GUI via:\n"+
          "java -jar PictureFrame.jar\n\n"+
          "Press \"esc\" to stop show, spacebar to pause\n\n"+
          "See www.medcosm.com for additional information.",
          "MedCosm Picture Frame v"+Application.versionStr,
         JOptionPane.PLAIN_MESSAGE);
  }

  public void run()
  {
      startSlideShow();
  }

  void jButtonFPbrowse_actionPerformed(ActionEvent e)
  {
    if(jfcSrc==null)
      jfcSrc=new JFileChooser(".");

    class MyFilter extends javax.swing.filechooser.FileFilter   //filter for JPG files only
    {
            public boolean accept(File file)
            {
                String filename = file.getName();
                return (filename.toLowerCase().endsWith(".jpeg") ||
                    filename.toLowerCase().endsWith(".jpg"));
            }
            public String getDescription()
            {
                return "JPEG images";
            }
    }

//    jfcSrc.setFileFilter(new MyFilter());   //apply filter

    jfcSrc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

    int returnVal = jfcSrc.showOpenDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      jTextFieldFilePath.setText(jfcSrc.getSelectedFile().toString());

      if(jfcSrc.getSelectedFile().isDirectory())
        jFrameJPGquality.setOutputDir(jfcSrc.getSelectedFile().toString());
      else
      if(jfcSrc.getSelectedFile().isFile())
        jFrameJPGquality.setOutputDir(jfcSrc.getSelectedFile().getParentFile().toString());
      else
        jFrameJPGquality.setOutputDir(".");
    }
  }

  void JButtonPlay_actionPerformed(ActionEvent e)
  {
    if(thread==null || !thread.isAlive())
    {
      if(jRadioButtonRandom.isSelected())
        playMode=PLAYMODE_RANDOM;
      else
        playMode=PLAYMODE_SEQUENTIAL;

      thread=new Thread(this);
      thread.start();
    }
  }

  void jSliderInterval_mouseReleased(MouseEvent e)
  {
    jTextFieldInterval.setText(""+jSliderInterval.getValue());
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      jMenuItemExit_actionPerformed(null);
    }
  }


  public void setParameters(int delay, String dir, boolean border, int playMode)
  {
    modeCLI=true; //we must be running from the CLI!

    jTextFieldInterval.setText(""+delay);
    jTextFieldFilePath.setText(dir);
    if(border)
      jRadioButtonWindow.setSelected(true);
    else
      jRadioButtonFullScreen.setSelected(true);
    if(playMode==PLAYMODE_RANDOM)
      jRadioButtonRandom.setSelected(true);
    else
      jRadioButtonSequential.setSelected(true);

    this.playMode=playMode;
  }


  public void createPictureFrame()
  {
    if(pictureframe!=null)
      pictureframe.dispose();

    pictureframe = new PictureFrame();

    pictureframe.setParentThread(this.thread);

    if(jRadioButtonFullScreen.isSelected())
      pictureframe.setUndecorated(true);
    else
      pictureframe.setUndecorated(false);
  }


  //Construct the application
  public void startSlideShow()
  {
    System.out.print("Starting slideshow\n");
    createPictureFrame();

    boolean packFrame=false;
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame)
    {
      pictureframe.pack(); //packs frame around contents
    }
    else
    {
      pictureframe.validate();   //expands frame and contents to fill specified size
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

    pictureframe.setSize(screenSize);
    pictureframe.setLocation(0,0);
    pictureframe.validate();
    pictureframe.setVisible(true);

    File fSrc=new File(jTextFieldFilePath.getText());

    File picsAvailable[]=fSrc.listFiles(); //must save current pic directory snapshot since we may change it (by writing dated files)

    if(!fSrc.isDirectory())
    {
      System.out.print("Not a valid directory!");
      System.exit(0);
    }

    int loopCount=0;

    while (pictureframe.isVisible())  //loop until pf is killed
    {
//      System.out.print("lc="+loopCount+" pm="+playMode+" cpi="+currentPicIdx+" \n");
      if(playMode==PLAYMODE_SAVE_PICTURES && loopCount!=0)
      {
        pictureframe.dispose();
        break;  //break if already dated all pictures
      }

      try
      {
        if(playMode==PLAYMODE_RANDOM)
          currentPicIdx=(int)(Math.random()*picsAvailable.length);
        else  //playmode == DATEPICS or SEQUENTIAL
        {
          currentPicIdx=(currentPicIdx+1);

          if(currentPicIdx>=picsAvailable.length)
          {
            currentPicIdx = currentPicIdx % picsAvailable.length;
            loopCount++;
          }
        }

        String fileName = picsAvailable[currentPicIdx].getCanonicalPath();

        int aspectMode;
        if(jRadioButtonDistort.isSelected() || playMode==PLAYMODE_SAVE_PICTURES)
          aspectMode=PictureFrame.MODE_FULLSCREEN;
        else
          aspectMode=PictureFrame.MODE_WINDOWED_RESCALED;

        int cpuMode;
        if(jRadioButtonMenuItemCPUfast.isSelected() || playMode==PLAYMODE_SAVE_PICTURES)
          cpuMode=PictureFrame.MODE_CPU_FAST;
        else
          cpuMode=PictureFrame.MODE_CPU_SLOW;

        boolean saveImage=(playMode==PLAYMODE_SAVE_PICTURES);

        String saveDir=jFrameJPGquality.getOutputDir();

        pictureframe.loadImageFile(fileName, jCheckBoxDate.isSelected(), aspectMode,
            cpuMode, saveImage, saveDir, (float)(jFrameJPGquality.getJPGquality()/100.0),
            jFrameJPGquality.getJPGSize());

        if(playMode!=PLAYMODE_SAVE_PICTURES)
          Thread.sleep(Integer.parseInt(jTextFieldInterval.getText()) * 1000);
        else
          Thread.sleep(250);  //sleep for a moment to allow swing to do its thing on slow machines
      }
      catch (IOException ex)
      {
        ex.printStackTrace();
      }
      catch (InterruptedException ex)
      {
//        System.out.print("Pause="+pictureframe.getPauseMode()+"\n");
      }
      catch (NumberFormatException ex)
      {
        ex.printStackTrace();
      }
    }
    System.out.print("Finished slideshow\n");

    if(modeCLI)   //exit if run from CLI
      System.exit(0);
  }

  void jRadioButtonWindow_actionPerformed(ActionEvent e)
  {
    setAspectGUI();
  }

  void jRadioButtonFullScreen_actionPerformed(ActionEvent e)
  {
    setAspectGUI();
  }

  void setAspectGUI()
  {
    if(jRadioButtonWindow.isSelected())
    {
      jRadioButtonDistort.setEnabled(false);
      jRadioButtonPreserveAspect.setEnabled(false);
    }
    else
    {
      jRadioButtonDistort.setEnabled(true);
      jRadioButtonPreserveAspect.setEnabled(true);
    }
  }

  void jMenuItemOutputImages_actionPerformed(ActionEvent e)
  {
    playMode=PLAYMODE_SAVE_PICTURES;
    if(thread==null || !thread.isAlive())
    {
      thread=new Thread(this);
      thread.start();
    }
  }

  void jMenuItemSetOutputParam_actionPerformed(ActionEvent e)
  {

    if(!jFrameJPGquality.isVisible())
    {
      //Validate frames that have preset sizes
      //Pack frames that have useful preferred size info, e.g. from their layout
      jFrameJPGquality.pack();
      //Center the window
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = jFrameJPGquality.getSize();
      if (frameSize.height > screenSize.height)
      {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width)
      {
        frameSize.width = screenSize.width;
      }
      jFrameJPGquality.setLocation((screenSize.width - frameSize.width) / 2,
          ((screenSize.height / 2) - frameSize.height )- (int)(this.getSize().getHeight() / 2));
      jFrameJPGquality.setVisible(true);
    }
  }

}